/*
 * Design and developed by Hemelix
 * Free to use, if you think this help you consider helping Hemelix
 * Visit http://www.hemelix.com/spriteanimationcocos2d
 * GameLayer.java 
 * version 1.0
 */

package com.hemelix.gametemplate;

import org.cocos2d.layers.CCColorLayer;
import org.cocos2d.layers.CCScene;
import org.cocos2d.actions.base.CCRepeatForever;
import org.cocos2d.actions.interval.CCAnimate;
import org.cocos2d.actions.interval.CCIntervalAction;
import org.cocos2d.nodes.CCAnimation;
import org.cocos2d.nodes.CCDirector;
import org.cocos2d.nodes.CCSprite;
import org.cocos2d.nodes.CCSpriteSheet;
import org.cocos2d.types.CGPoint;
import org.cocos2d.types.CGRect;
import org.cocos2d.types.CGSize;
import org.cocos2d.types.ccColor4B;

import android.util.Log;

public class GameLayer extends CCColorLayer {

    private static final String TAG = "GameLayer";
    CCSprite walkingGirl;
    CCIntervalAction actionC;
    float xPoint = 200.0000000f;
    int screenWidth = 0;

    public static CCScene scene() {

        CCScene scene = CCScene.node();
        //Make the screen white color
        CCColorLayer layer = new GameLayer(ccColor4B.ccc4(255, 255, 255, 255));
        scene.addChild(layer);
        return scene;
    }

    protected GameLayer(ccColor4B color) {
        super(color);
        super.isTouchEnabled_ = true;
    }

    @Override
    public void onEnter() {
        super.onEnter();
        schedule("createCCSpriteSheet");
    }

    public void createCCSpriteSheet(float dt) {
        Log.d(TAG, "><createCCSpriteSheet");
        unschedule("createCCSpriteSheet");
        CGSize s = CCDirector.sharedDirector().winSize();
        screenWidth = (int) s.width;
        CCSpriteSheet sheetA = CCSpriteSheet.spriteSheet("walkinggirl.png", 20);
        walkingGirl = CCSprite.sprite(sheetA.getTexture(),
                CGRect.make(0, 0, 125, 125));
        walkingGirl.setPosition(CGPoint.make(s.width / 2, s.height / 2));
        CCAnimation animation = CCAnimation.animation("dance", 0.2f);
        for (int i = 0; i < 20; i++) {
            int x = i % 4;
            int y = i / 5;
            animation.addFrame(sheetA.getTexture(),
                    CGRect.make(x * 125, y * 125, 125, 125));
        }
        actionC = CCAnimate.action(animation);
        walkingGirl.runAction(CCRepeatForever.action(actionC));
        sheetA.addChild(walkingGirl);
        schedule("changeCCSpriteSheetPoint");
        addChild(sheetA);
    }

    public void changeCCSpriteSheetPoint(float dt) {

        // xPoint++;
        walkingGirl.setPosition(CGPoint.make(xPoint, 300));
        if (CGRect.minX(walkingGirl.getBoundingBox()) >= screenWidth) {
            unschedule("changeCCSpriteSheetPoint");
            int tag = walkingGirl.getTag();
            walkingGirl.stopAllActions();
            removeChild(tag, true);
            schedule("createCCSpriteSheet", 1.0f);
        }
    }

    private void removeChild(int tag2, boolean cleanup) {
        super.removeChild(this, cleanup);
    }

    @Override
    public void onExit() {
        super.onExit();
    }
}
